/*
main.c
 * Date: May 01, 2014
 * Description: This code is mean to blink a LED, then Pass a message to LCD, waits for user to press the key and displays how manyh times the key was pressed in a single run of the device.
 */

#include "main.h"

//Global Variables
char strDispla[4];

/*
main
Date: May 01, 2014
param: void
return: void
Description:
*/
int main(void)
{

    unsigned char numCnt = 0;
    unsigned int numPressCount = 0;

    set_input(PORT_DIR_KEY,KEY_1);

    // LED has been connected over Port A, Pin 3 (PA3). Set this pin to be Output pin.
    PORT_DIR_LED = 1<<PIN_LED;

    //Pull Down all the pins of PORTA.
    PORT_LED = 0;
    numCnt = 0;

    for (numCnt = 0; numCnt < 4; numCnt++)
    {
      PORT_LED ^= 1<<PIN_LED;
        _delay_ms (500);
    }

    // Insert code
    lcd_init(LCD_DISP_ON);
    lcd_clrscr();
    lcd_gotoxy(0,0);
    lcd_puts("spellbound");

    while(1)
    {
      if(bit_is_set(PORT_IN_KEY, KEY_1))
      {

        //check if the key is still pressed after the delay above. If yes then only treat as a key-pressed event. This is for key-debouncing.
        _delay_ms(100);

        //check if the key is still pressed. If yes then proceed, else do nothing.
        if(bit_is_set(PORT_IN_KEY, KEY_1))
        {
          numPressCount += 1;

          getStringFromNumber((uint32_t)numPressCount, strDispla, 0);
          lcd_clrscr();
          lcd_gotoxy(0, 0);
          lcd_puts((const char*)strDispla);
        }
      }
    }

    return 0;
}

/*
getStringFromNumber
Date: November 04, 2012
param: uint16_t numIn, char* strOut, char FlgFloat
return: void
author: Vigyan Ashram
Description:
	* Provides number as a string in strOut.
	* Assumes that decimal point will be at 7th place from right, as the system frequency is in MHz.
	* Hence, 2424722 become 0002.424722 here and 2 become 0000.000002. Note the place for decimal point is 7.
	* chrFlgFloat decides whether a number is to be treated as an integer or a float and displays accordingly.
	* This code has been written to bypass floating point arithmetic while achieving answers that are rel numbers.
*/
void getStringFromNumber(uint32_t numIn, char* strOut, char chrFlgFloat)
{
	//Note - declaring following variables for every function call is resource consuming, however, declaring these one time (globally) causes a sharp rise in source code size and RAM usage (obviously).
	uint32_t numDiv = 0;
	uint32_t numMod = 0;
	uint32_t numCnt = 4;
	uint16_t numCnt1 = 0;

	numCnt = 4;
	numDiv = numIn;
	strOut[numCnt] = 0;												//Put a NULL at the end of the strOut String. The maximum number of digits is 6. Hence, 7th place is NULLed to indicate the end of string.

	while(1)
	{
		numMod = numDiv%10;
		numDiv = numDiv/10;

		if(chrFlgFloat)
		{
			numCnt1++;
			if (numCnt1 == 4)		//This counter becomes redundant if number is not of float type
			{
				--numCnt;
				strOut[4 - 2] = '.';
			}
		}

		--numCnt;
		strOut[numCnt] = numMod + 48;	//ASCII(0) = 48

		if (numDiv == 0)								//If all the numbers are handled
			break;
	}

	for (numMod = 0; numMod < numCnt; numMod++)			//Here, numMod is to be looked upon as only a generic counter. Nothing to do with mathematical MOD.
	{
		strOut[numMod] = '0';
	}

	//Following will be used in case floating point output is expected and number of digits in the 'numWidth' is less than 7
	if(chrFlgFloat && (numCnt1 < 2))
	{
		strOut[2] = '.';
	}
}
