/*
 * main.h
 * April 20, 2014
 * Fabacademy 2014
 */

#define F_CPU 1000000		//F_CPU is required to be provided for using delay.h. It is 1MHz in this code.

#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"

//Macro - PORTS
#define PIN_LED		PA1               //LED effects will take place on this pin.
#define PORT_LED 	PORTA
#define PORT_DIR_LED	DDRA

#define PORT_DIR_KEY	DDRB
#define PORT_IN_KEY	PINB      //The press-key has been connected over this pin.
#define KEY_1		PB2

//Macro - Functions
#define set_input(portdir,pin)	portdir &= ~(1<<pin)
#define set_pullup(port,pin)	port |= (1 << pin)
#define set_output(portdir,pin)	portdir |= (1<<pin)
#define output_low(port,pin)	port &= ~(1<<pin)
#define output_high(port,pin)	port |= (1<<pin)

/*
getStringFromNumber
Date: April 28, 2014
param: uint32_t numIn, char* strOut, char FlgFloat
return: void
Description:
	* Provides number as a string in strOut.
	* Assumes that decimal point will be at 7th place from right, as the system frequency is in MHz, provided chrFlahFloat = 1.
	* Hence, 2424722 become 0002.424722 here and 2 become 0000.000002. Note the place for decimal point is 7.
	* chrFlgFloat decides whether a number is to be treated as an integer or a float and displays accordingly.
	* This code has been written to bypass floating point arithmetic while achieving answers that are real numbers.
*/
void getStringFromNumber(uint32_t numIn, char* strOut, char chrFlgFloat);
